<template>
  <v-container>
    <v-row>
      <v-col>
        <v-menu
          ref="menu1"
          v-model="menu1"
          :close-on-content-click="false"
          transition="scale-transition"
          max-width="auto"
          min-width="auto"
          style="z-index:10"
        >
          <template #activator="{ on, attrs }">
            <v-text-field
              v-model="dateFormatted"
              outlined
              readonly
              persistent-hint
              append-icon="mdi-calendar"
              v-bind="attrs"
              v-on="on"
              background-color="white"
            />
          </template>
          <v-date-picker
            v-model="date"
            locale="es-PE"
            color="primary"
            @input="menu1 = false"
            @change="changeDate(date)"
          />
        </v-menu>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import moment from 'moment-timezone';
export default {
  name: 'DatePicker',
  props: {
    changeFunction: Function,
  },
  data: vm => ({
    date: moment().tz('America/Lima').format().substr(0, 10),
    dateFormatted: vm.formatDate(moment().tz('America/Lima').format().substr(0, 10)),
    menu1: false,
    menu2: false,
    nowDate: moment().tz('America/Lima').format().slice(0, 10),
  }),

  computed: {
    computedDateFormatted() {
      return this.formatDate(this.date);
    },
  },

  watch: {
    date(val) {
      this.dateFormatted = this.formatDate(val);
      console.log('CHANGE', val);
    },
  },

  methods: {
    changeDate(date) {
      this.changeFunction(date);
      this.date = date;
      this.dateFormatted = this.formatDate(date);
      console.log('CHANGE', date);
    },
    formatDate(date) {
      if (!date) { return null; }

      const [year, month, day] = date.split('-');
      const months = ['enero', 'febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto',
        'setiembre', 'octubre', 'noviembre', 'diciembre'];
      return `${day} de ${months[month - 1]} del ${year}`;
    },
    parseDate(date) {
      if (!date) { return null; }

      const months = ['enero', 'febrero', 'marzo', 'abril', 'mayo', 'junio', 'julio', 'agosto',
        'setiembre', 'octubre', 'noviembre', 'diciembre'];
      const dateArray = date.split(' ');
      const day = dateArray[0];
      const month = (months.indexOf(dateArray[2]) + 1).toString();
      const year = dateArray[4];
      return `${year}-${month.padStart(2, '0')}-${day.padStart(2, '0')}`;
    },
  },
};
</script>
